<?php

add_action('wp_ajax_speakout_revoke_licence_key', 'speakout_revoke_licence_key');
add_action('wp_ajax_nopriv_speakout_revoke_licence_key', 'speakout_revoke_licence_key');

 function speakout_revoke_licence_key($action) {
    $the_license_key_value = get_option( "dk_speakout_license_key" ); 
    $the_domain = $_SERVER['SERVER_NAME'];
    
    $curl = curl_init();

    $url = "https://license.speakout.123host.net.au?key=" . $the_license_key_value . "&action=revoke&domain=" . $the_domain . "&version=" . get_option( 'dk_speakout_version');

    curl_setopt_array($curl, array(
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "GET",
    ));
    
    $response = curl_exec($curl);
    //$err = curl_error($curl);

    //The API returns data in JSON format, so first convert that to an array of data objects
    $responseObj = json_decode($response, true);

    
    // if license key is being revoked
    if ($responseObj["status"] == "revoked"){
    
        for($i = 1; $i <= 3; $i++){
            
            // set up to get the original file fron the WordPress repository
            $filename = $responseObj["returnFile".$i] ;
            $url = "https://plugins.svn.wordpress.org/speakout/trunk/includes/" . $filename . ".php";
            
            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_USERAGENT =>'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/525.13 (KHTML, like Gecko) Chrome/0.A.B.C Safari/525.13'
            ));
    
            $response = curl_exec($curl);
            //$err = curl_error($curl);
            
            $thefile = dirname(__FILE__) . "/" . $filename . ".php";

            //write to the file
            $doWrite = fopen( $thefile , "w");
            fwrite($doWrite, $response); 
            fclose($doWrite);
            
        
            $files = scandir(dirname(__FILE__));
            foreach($files as $file) {
                touch(dirname(__FILE__) . "/" .$file);
            }
        
        }  
        curl_close($curl);
        
        // delete the license key
        delete_option('dk_speakout_license_key');
    	update_option('dk_speakout_license_key_verified','0');
    }
 }

add_action('wp_ajax_speakout_verify_licence_key', 'speakout_verify_licence_key');
add_action('wp_ajax_nopriv_speakout_verify_licence_key', 'speakout_verify_licence_key');

 function speakout_verify_licence_key($action) {
     
    if(isset($_POST['key'])){
        $the_license_key_value = $_POST['key'];
    }
    else{
        $the_license_key_value = get_option( 'dk_speakout_license_key' );
    }
    $the_domain = $_SERVER['SERVER_NAME'];

    if($action == "upgrade"){        
        $the_license_key_value = get_option( "dk_speakout_license_key" );       
    }
    if ($the_license_key_value == "" ) return; 
     
	$curl = curl_init();

    $url = "https://license.speakout.123host.net.au?key=" . $the_license_key_value ."&domain=" . $the_domain . "&action=upgrade&version=" . get_option( 'dk_speakout_version' );
    
    curl_setopt_array($curl, array(
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "GET",
    ));
    $response = curl_exec($curl);
    //$err = curl_error($curl);
    curl_close($curl);
  
        //The API returns data in JSON format, so first convert that to an array of data objects
        $responseObj = json_decode($response, true);

    if ($responseObj["status"] == "valid"){
    
        for($i = 1; $i <= 3; $i++){
            $filename = $responseObj["returnFile".$i] ;
            $incomingURL = "https://license.speakout.123host.net.au/" . $filename . ".txt";
            $getFile = file_get_contents($incomingURL);
            $thefile = dirname(__FILE__) . "/" .$filename . ".php";
            $doWrite = fopen( $thefile , "w");
            fwrite($doWrite, $getFile); 
            fclose($doWrite);
        }
        
        $files = scandir(dirname(__FILE__));
        foreach($files as $file) {
          touch(dirname(__FILE__) . "/" .$file);
        }
    }

if($action == "upgrade"){ return; }

//////////////////////////////////////////////////////////////////////
$response = array();

$response["status"]=$responseObj["status"];
$response["license_key"]=$responseObj["key"];
$response["licence_key_verified"]="1";

if($response["status"]=='valid'){
    
    update_option('dk_speakout_license_key', $response["license_key"]);
	update_option('dk_speakout_license_key_verified','1');
}

echo json_encode($response);
    
     exit;
 }
?>